import 'package:flutter/cupertino.dart';
import 'package:indigitall_flutter_plugin/core/utils/PreferenceUtils.dart';
// import 'package:package_info/package_info.dart';

class CoreRequest{

  static const TAG = "[IND]CoreRequest";
  static const String PARAM_APP_KEY = "appKey";
  static const String PARAM_DEVICE_ID = "deviceId";
  static const String PARAM_ENABLED = "enabled";
  static const String PARAM_PLATFORM = "platform";
  static const String PARAM_TOPICS = "topics";
  static const String PARAM_EVENT_TYPE = "eventType";
  static const String PARAM_EVENT_NETWORK_CONNECTED = "wifiConnected";
  static const String PARAM_EVENT_NETWORK_SSID = "wifiSSID";
  static const String PARAM_PUSH_ID = "pushId";
  static const String PARAM_CLICKED_BUTTON = "clickedButton";
  static const String PARAM_PERMISSION_TYPE = "permissionType";
  static const String PARAM_LATITUDE = "latitude";
  static const String PARAM_LONGITUDE = "longitude";
  static const String PARAM_INAPP_ID = "inAppId";
  static const String PARAM_INAPP_EVENT_TYPE = "eventType";
  static const String PARAM_INAPP_CLICKED_BUTTON = "clickedButton";
  static const String PARAM_INAPP_LAST_VERSION_ID = "lastVersionId";
  static const String PARAM_INBOX_EXTERNAL_ID = "externalId";
  static const String PARAM_INBOX_PAGE = "page";
  static const String PARAM_INBOX_PAGE_SIZE = "pageSize";
  static const String PARAM_INBOX_DATE_FROM = "dateFrom";
  static const String PARAM_INBOX_DATE_TO = "dateTo";
  static const String PARAM_INBOX_STATUS = "status";
  static const String PARAM_SENDER_IDS = "sendingIds";
  static const String PARAM_DEVICE_SECURED_DATA = "securedData";
  static const String PARAM_DEVICE_SECURED_KEY = "securedKey";
  static const String PARAM_INBOX_EVENT_SENDING_ID = "sendingId";
  static const String PARAM_INBOX_EVENT_EXTERNAL_CODE = "externalCode";
  static const String PARAM_EVENT_CUSTOM_DATA = "customData";

  late String packageName;
  late String appKey;

  late String params;
  Map? body;
  Map<String, String> path = Map<String, String>();
  Map<String, String> headers = Map<String, String>();

  CoreRequest() {
    PreferenceUtils.getAppKey().then((value) => {
      this.appKey = value
    });

    getPackageName().then((value) => {
      this.packageName = value
    });
  }

  Future<String> getPackageName() async {
    // return await PackageInfo.fromPlatform().then((value) => value.packageName);
    return "";
  }

  String getParams() {
    return "?" + PARAM_APP_KEY + "=" + appKey + (params != null ? "&" + params : "");
  }

  String getBody() {
    try {
      if (body != null) {
        try {
          return body.toString().padLeft(4);
        } on Exception catch (_) {
          return body.toString();
        }
      }
    }on Exception catch (exception){
      print(exception);
    }
    return "";
  }

  String getPath(String url) {
    try {
      if (path != null) {
        path.forEach((key, value) {
          url = url.replaceAll(key, value);
        });
      }
      return url;
    }on Exception catch(exception){
      print(exception);
    }
    return "";
  }

  List addHeaders() {
    List httpProperty = [];
    try {
      if (headers != null) {
        List keys = headers.keys.toList();
        List values = headers.values.toList();
        for (var i = 0; i < keys.length; i++) {
          String value = values[i];
          if (value != null) {
            httpProperty[0] = keys[i];
            httpProperty[1] = value;
            return httpProperty;
          }
        }
      }
    }on Exception catch(exception){
      print(exception.toString());
    }
    return httpProperty;
  }
}

