import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:indigitall_flutter_plugin/core/models/ErrorModel.dart';
// import 'package:logger/logger.dart';

import 'PreferenceUtils.dart';

class Log {
  static const int _DEBUG = 1;
  static const int _INFO = 2;
  static const int _WARNING = 3;
  static const int _ERROR = 4;

  static String _tag = "[IND]";
  static dynamic _log = "";
  static int _level = _DEBUG; // 1 = Debug, 2 = Info, 3 = Warning, 4 = Error
  // Logger _logger = new Logger(printer: PrettyPrinter(colors: true, printEmojis: false, methodCount: 0));
  int _typeLevel = _DEBUG;

  Log(String TAG) { Log.withContext(null, TAG); }

  Log.withContext(BuildContext? context, String TAG) { Log.withLevel(_DEBUG, TAG, context); }

  Log.withLevel(int? level, String TAG, BuildContext? context) {
    _tag = TAG;
    if (level != null && level >= _DEBUG && level <= _ERROR) {
      _level = level;
    }

    // if (context != null) {
    //   //PreferenceUtils.getLogDebug().then((logDebug) {
    //   var logDebug = true;
    //     if (logDebug != false && level != null && level >= _INFO && level < _ERROR) {
    //       _level = _WARNING;
    //     } else if (!logDebug && level != null && level == _ERROR) {
    //       _level = level;
    //     }
    //   //});
    // }
  }

  void writeLog() {

    if (_log.length > 0 ) {
      switch (_typeLevel){
        case _INFO: {
          // _logger.i(_tag + _log);
        }
        break;
        case _WARNING: {
          // _logger.w(_tag + _log);
        }
        break;
        case _ERROR: {
          // _logger.e(_log, _tag);
        }
        break;
        default:{
          // _logger.d(_tag + _log);
        }
      }

    }
    _log = "";
  }

  Log d(String message) {
    if (_level <= _DEBUG) {
      _log += message;
      _typeLevel = _DEBUG;
    }
    return this;
  }

  Log i(String message) {
    if (_level <= _INFO) {
      _log += message;
      _typeLevel = _INFO;
    }
    return this;
  }

  Log w(String message) {
    if (_level <= _WARNING) {
      _log += message;
      _typeLevel = _WARNING;
    }
    return this;
  }

  Log e(String message) {
    if (_level <= _ERROR) {
      _log += message;
      _typeLevel = _ERROR;
    }
    return this;
  }

  Log eWithError(ErrorModel error){
    if (_level <= _ERROR) {
      _log += error.errorCode.toString() + " :" + error.errorMessage.toString();
      _typeLevel = _ERROR;
    }
    return this;
  }
}